; ###########################################################################
; original source from donkey
; adapted/modified by denise_amiga

.586						; create 32 bit code
.model flat, stdcall		; 32 bit memory model
option casemap :none		; case sensitive

include	windows.inc
include kernel32.inc

	szLen	PROTO	:DWORD
	szCopy	PROTO	:DWORD,:DWORD

.code

; ###########################################################################

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 4

sa_Replace proc pArray:DWORD,iString:DWORD,pString:DWORD

_index		= 0*4											; \
_count		= 1*4											; | extra
_size		= 2*4											; | data
_reserved	= 3*4											; /
_array		= 4*4											; <- begin array

	push	ebx
	push	esi

	mov		ebx, [esp+3*4]									; pArray
	mov		ecx, [esp+4*4]									; iString
	mov		esi, [esp+5*4]									; pString
	mov		eax, [ebx+_size]								; size

	.if		(ecx <= 0) || (ecx > eax)						; inside limits?
		mov		eax, -1										; return -1
		jmp		@exit
	.endif

	mov		eax, [ebx+ecx*4+_reserved]						; base 1, get ptr
	test	eax, eax										; ptr null?
	jz		@F

	invoke	GlobalFree, eax
@@:
	invoke	szLen, esi
	push	eax												; store size
	add		eax, 5											; size + 0 terminator
	invoke	GlobalAlloc, GMEM_FIXED or GMEM_ZEROINIT, eax
	pop		ecx
	test	eax, eax										; no memory?
	jz		@exit											; return 0

	mov		[eax], ecx										; store size in string
	push	eax												; store ptr
	add		eax, 4											; skip size
	invoke	szCopy, esi, eax
	pop		eax
	mov		ecx, [esp+4*4]									; iString
	mov		[ebx+ecx*4+_reserved], eax						; write ptr to array

	mov		eax, ecx
@exit:
	pop		esi
	pop		ebx
	ret		3*4

sa_Replace endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; ###########################################################################

end
